import React from 'react';

export default class Modal extends React.Component{
  constructor(props){
    super(props)
    this.defaultOptions = {
      type: '', //modal-primary modal-info modal-warning modal-success
      title: 'Modal',
      content:'<p></p>',
      cancelCallback: false,
      deleteCallback: false,
      okCallback : false,
      cancelClass: 'btn-outline pull-left',
      deleteClass: 'btn-outline btn-danger',
      okClass: 'btn-outline btn-primary',
    };
  }
  render(){
    var options = Object.assign({}, this.defaultOptions, this.props.options);
    var cls = 'modal ' + options.type;
    return (
      <div className={cls} 
        ref="modal"
        style={{display:'block'}}>
        <div className="modal-dialog">
          <div className="modal-content">
            <div className="modal-header">
              <button type="button" className="close" data-dismiss="modal" 
                onClick={e=>{
                  e.preventDefault();
                  $(this.refs.modal).remove();
                  if(options.cancelCallback) {
                    options.cancelCallback(e);
                  }
                }}
                aria-label="Close">
                <span aria-hidden="true">×</span></button>
              <h4 className="modal-title">{options.title}</h4>
            </div>
            <div className="modal-body" dangerouslySetInnerHTML={{__html:options.content}}>
            </div>
            <div className="modal-footer">
              {this.generateFooter(options)}
            </div>
          </div>
        </div>
      </div>
    );
  }
  generateFooter(options){
    var html = [];
    if(options.cancelCallback){
      html.push(
        <button 
          type="button" 
          key="btn_cancel"
          className={'btn ' + options.cancelClass} 
          data-dismiss="modal"
          onClick={e=>{
            e.preventDefault();
            //$(this.refs.modal).remove();
            if(options.cancelCallback){
              options.cancelCallback(e);
            }
          }}
          >Cancel</button>);
    }
    if(options.deleteCallback){
      html.push(
        <button 
          type="button" 
          key="btn_delete"
          className={'btn ' + options.deleteClass}
          onClick={e=>{
            e.preventDefault();
            if(options.deleteCallback){
              options.deleteCallback(e);
            }
          }}>Delete</button>);
    }
    if(options.okCallback){
      html.push(
        <button 
          type="button" 
          key="btn_ok"
          className={'btn ' + options.okClass}
          onClick={e=>{
            e.preventDefault();
            if(options.okCallback){
              options.okCallback(e)
            }
          }}>OK</button>);
    }
    return html;
  }
}